/* Copyright 1989 CSIRO Division of Information Technology 
 * May be given away but not sold for profit - See Copyright file for details
 */
/*
 * Routine to convert a type_DSE_PSAPaddr structure into PSAPaddr structure
 * which pepsy generated decoder accepts
 */
#include <stdio.h>
#include "psap.h"
#include "isoaddrs.h"
#include "tailor.h"
#include "DSE-types.h"

#define advise	PY_advise

extern struct type_DSE_PSAPaddr *psap2dse();
extern struct PSAPaddr *dse2psap();

build_DSE_PSAPaddr(pe, explicit, len, buffer, parm)
register PE     *pe;
int     explicit;
int     len;
char   *buffer;
char	*parm;
{
    struct PSAPaddr	*psap = (struct PSAPaddr *)parm;
    struct type_DSE_PSAPaddr	*dse;
    if ((dse = psap2dse(psap)) == NULL) {
	advise(NULLCP, "psap2dse:failed");
	return (NOTOK);
    }

    encode_DSE_PSAPaddr(pe, explicit, len, buffer, (char *)dse);

    free_DSE_PSAPaddr(dse);
}

parse_DSE_PSAPaddr (pe, explicit, len, buffer, parm)
register PE     pe;
int     explicit;
int    *len;
char  **buffer;
char **parm;
{
    struct PSAPaddr	*psap;
    struct type_DSE_PSAPaddr	*dse;

    if ((decode_DSE_PSAPaddr(pe, explicit, len, buffer, &dse)) == NOTOK) {
	advise(NULLCP, "PSAPaddr couldn't decode");
	return (NOTOK);
    }

    if ((psap = dse2psap(dse)) == NULL) {
	advise(NULLCP, "dse2psap:failed");
	return (NOTOK);
    }

    free_DSE_PSAPaddr(dse);

    *(struct PSAPaddr **)parm = psap;

    return (OK);
}

