/* Copyright 1989 CSIRO Division of Information Technology 
 * May be given away but not sold for profit - See Copyright file for details
 */
#include <stdio.h>
#include "psap.h"
#include "isoaddrs.h"
#include "NS-types.h"

build_NS_Query (pe, explicit, len, buffer, ns)
register PE     *pe;
int	explicit;
int	len;
char   *buffer;
struct ns_query *ns;
{
    struct type_NS_Query	parm;
    int	retcode;

    parm.request__id = ns->ns_id;
    parm.name = str2qb(ns->ns_name, strlen(ns->ns_name), 1);
    parm.attribute = str2qb(ns->ns_attribute, strlen(ns->ns_attribute), 1);

    retcode = encode_NS_Query(pe, explicit, len, buffer, &parm);

    qb_free(parm.name);
    qb_free(parm.attribute);

    return (retcode);
}

build_NS_Response (pe, explicit, len, buffer, parm)
register PE     *pe;
int	explicit;
int	len;
char   *buffer;
char *parm;
{
    return (encode_NS_Response(pe, explicit, len, buffer, parm));
}

parse_NS_Query (pe, explicit, len, buffer, parm)
register PE	pe;
int	explicit;
int    *len;
char  **buffer;
char	**parm;
{
    return (decode_NS_Query(pe, explicit, len, buffer, parm));
}

parse_NS_Response (pe, explicit, len, buffer, parm)
register PE	pe;
int	explicit;
int    *len;
char  **buffer;
char **parm;
{
    return (decode_NS_Response(pe, explicit, len, buffer, parm));
}
